import { CompletionContext, CompletionResult } from "@codemirror/autocomplete";
import { JSONSchema7 } from "json-schema";
import { JsonError } from "json-schema-library";
export declare class JSONCompletion {
    private schema;
    constructor(schema: JSONSchema7);
    doComplete(ctx: CompletionContext): CompletionResult;
    private applySnippetCompletion;
    private getPropertyCompletions;
    private getInsertTextForProperty;
    private getInsertTextForGuessedValue;
    private getInsertTextForPlainText;
    private getInsertTextForValue;
    private getValueCompletions;
    private addSchemaValueCompletions;
    private addDefaultValueCompletions;
    private addEnumValueCompletions;
    private addBooleanValueCompletion;
    private addNullValueCompletion;
    private collectTypes;
    private getSchemas;
    isJsonError(d: JSONSchema7 | JsonError): d is JsonError;
    private expandSchemaProperty;
    private getReferenceSchema;
    private getLabelForValue;
    private getValueFromLabel;
    private extendedRegExp;
}
/**
 * provides a JSON schema enabled autocomplete extension for codemirror
 * @group Codemirror Extensions
 */
export declare function jsonCompletion(schema: JSONSchema7): (ctx: CompletionContext) => CompletionResult;
